Documentation: quote {non-attributes} for asciidoc
[git/dscho.git] / git-stash.sh
blob18d3322ab5d57c8dc8e1333fc007861ef89e2d6d
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 . git-sh-setup
7 require_work_tree
9 TMP="$GIT_DIR/.git-stash.$$"
10 trap 'rm -f "$TMP-*"' 0
12 ref_stash=refs/stash
14 no_changes () {
15 git-diff-index --quiet --cached HEAD &&
16 git-diff-files --quiet
19 clear_stash () {
20 logfile="$GIT_DIR/logs/$ref_stash" &&
21 mkdir -p "$(dirname "$logfile")" &&
22 : >"$logfile"
25 save_stash () {
26 if no_changes
27 then
28 echo >&2 'No local changes to save'
29 exit 0
31 test -f "$GIT_DIR/logs/$ref_stash" ||
32 clear_stash || die "Cannot initialize stash"
34 # state of the base commit
35 if b_commit=$(git-rev-parse --verify HEAD)
36 then
37 head=$(git-log --abbrev-commit --pretty=oneline -n 1 HEAD)
38 else
39 die "You do not have the initial commit yet"
42 if branch=$(git-symbolic-ref -q HEAD)
43 then
44 branch=${branch#refs/heads/}
45 else
46 branch='(no branch)'
48 msg=$(printf '%s: %s' "$branch" "$head")
50 # state of the index
51 i_tree=$(git-write-tree) &&
52 i_commit=$(printf 'index on %s' "$msg" |
53 git-commit-tree $i_tree -p $b_commit) ||
54 die "Cannot save the current index state"
56 # state of the working tree
57 w_tree=$( (
58 GIT_INDEX_FILE="$TMP-index" &&
59 export GIT_INDEX_FILE &&
61 rm -f "$TMP-index" &&
62 git-read-tree $i_tree &&
63 git-add -u &&
64 git-write-tree &&
65 rm -f "$TMP-index"
66 ) ) ||
67 die "Cannot save the current worktree state"
69 # create the stash
70 w_commit=$(printf 'WIP on %s' "$msg" |
71 git-commit-tree $w_tree -p $b_commit -p $i_commit) ||
72 die "Cannot record working tree state"
74 git-update-ref -m "$msg" $ref_stash $w_commit ||
75 die "Cannot save the current status"
76 printf >&2 'Saved WIP on %s\n' "$msg"
79 have_stash () {
80 git-rev-parse --verify $ref_stash >/dev/null 2>&1
83 list_stash () {
84 have_stash || return 0
85 git-log --pretty=oneline -g "$@" $ref_stash |
86 sed -n -e 's/^[.0-9a-f]* refs\///p'
89 show_stash () {
90 flags=$(git-rev-parse --no-revs --flags "$@")
91 if test -z "$flags"
92 then
93 flags=--stat
95 s=$(git-rev-parse --revs-only --no-flags --default $ref_stash "$@")
97 w_commit=$(git-rev-parse --verify "$s") &&
98 b_commit=$(git-rev-parse --verify "$s^") &&
99 git-diff $flags $b_commit $w_commit
102 apply_stash () {
103 git-diff-files --quiet ||
104 die 'Cannot restore on top of a dirty state'
106 # current index state
107 c_tree=$(git-write-tree) ||
108 die 'Cannot apply a stash in the middle of a merge'
110 s=$(git-rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
111 w_tree=$(git-rev-parse --verify "$s:") &&
112 b_tree=$(git-rev-parse --verify "$s^:") ||
113 die "$*: no valid stashed state found"
115 eval "
116 GITHEAD_$w_tree='Stashed changes' &&
117 GITHEAD_$c_tree='Updated upstream' &&
118 GITHEAD_$b_tree='Version stash was based on' &&
119 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
122 if git-merge-recursive $b_tree -- $c_tree $w_tree
123 then
124 # No conflict
125 a="$TMP-added" &&
126 git-diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
127 git-read-tree --reset $c_tree &&
128 git-update-index --add --stdin <"$a" ||
129 die "Cannot unstage modified files"
130 git-status
131 rm -f "$a"
132 else
133 # Merge conflict; keep the exit status from merge-recursive
134 exit
138 # Main command set
139 case "$1" in
140 list | '')
141 test $# -gt 0 && shift
142 if test $# = 0
143 then
144 set x -n 10
145 shift
147 list_stash "$@"
149 show)
150 shift
151 show_stash "$@"
153 apply)
154 shift
155 apply_stash "$@"
157 clear)
158 clear_stash
160 save)
161 save_stash && git-reset --hard
164 usage
165 esac